| Flutter Impeller |

Public Member Functions | List of all members
impeller::RectGeometry Class Referencefinal

`#include <rect_geometry.h>`

Inheritance diagram for impeller::RectGeometry:

## Public Member Functions
| RectGeometry (Rect rect)
| ~RectGeometry ()=default
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::shared_ptr< Geometry > | MakeFillPath (Path path, std::optional< Rect > inner_rect=std::nullopt)
static std::shared_ptr< Geometry > | MakeStrokePath (Path path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::shared_ptr< Geometry > | MakeCover ()
static std::shared_ptr< Geometry > | MakeRect (const Rect &rect)
static std::shared_ptr< Geometry > | MakeOval (const Rect &rect)
static std::shared_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::shared_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::shared_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::shared_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::shared_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)
Static Protected Member Functions inherited from impeller::Geometry
static GeometryResult | ComputePositionGeometry (const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)
static GeometryResult | ComputePositionUVGeometry (const Tessellator::VertexGenerator &generator, const Matrix &uv_transform, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 12 of file rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ RectGeometry()

impeller::RectGeometry::RectGeometry | ( | Rect | rect | ) |
| explicit

Definition at line 9 of file rect_geometry.cc.

9 : rect_(rect) {}

## ◆ ~RectGeometry()

impeller::RectGeometry::~RectGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 47 of file rect_geometry.cc.

47 {
48 if (!transform.IsTranslationScaleOnly()) {
49 return false;
50 }
51 Rect coverage = rect_.TransformBounds(transform);
52 return coverage.Contains(rect);
53 }

References impeller::TRect< T >::Contains(), impeller::Matrix::IsTranslationScaleOnly(), and impeller::TRect< T >::TransformBounds().

## ◆ IsAxisAlignedRect()

bool impeller::RectGeometry::IsAxisAlignedRect | ( |  | ) | const
| override virtual

Reimplemented from impeller::Geometry.

Definition at line 55 of file rect_geometry.cc.

55 {
56 return true;
57 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/rect_geometry.h
- impeller/entity/geometry/rect_geometry.cc

impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:264
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:488
impeller::TRect::Contains
constexpr bool Contains(const TPoint< Type > &p) const
Definition: rect.h:127